/**
 * BSD-style license; for more info see http://pmd.sourceforge.net/license.html
 */
/* Generated By:JJTree: Do not edit this line. ASTConditionalExpression.java */

package net.sourceforge.pmd.lang.java.ast;

import net.sourceforge.pmd.lang.ast.Node;


/**
 * Represents a conditional expression, aka ternary expression. This operation has
 * a greater precedence as {@linkplain ASTExpression assignment expressions},
 * and lower as {@link ASTConditionalOrExpression}.
 *
 * <p>Note that the children of this node are not necessarily {@link ASTConditionalOrExpression},
 * rather, they are expressions with an operator precedence greater or equal to ConditionalOrExpression.
 *
 * <pre>
 *
 * ConditionalExpression ::= {@linkplain ASTConditionalOrExpression ConditionalOrExpression} "?"  {@linkplain ASTExpression Expression} ":" {@linkplain ASTConditionalExpression ConditionalExpression}
 *
 * </pre>
 *
 */
public class ASTConditionalExpression extends AbstractJavaTypeNode {


    public ASTConditionalExpression(int id) {
        super(id);
    }

    public ASTConditionalExpression(JavaParser p, int id) {
        super(p, id);
    }


    /**
     * @deprecated To be removed in 7.0.0
     */
    @Deprecated
    public void setTernary() {
        // noop
    }


    /**
     * This method always returns true.
     *
     * @deprecated To be removed in 7.0.0
     */
    @Deprecated
    public boolean isTernary() {
        return true;
    }


    /**
     * Returns the node that represents the guard of this conditional.
     * That is the expression before the '?'.
     */
    public Node getGuardExpressionNode() {
        return jjtGetChild(0);
    }


    /**
     * Returns the node that represents the expression that will be evaluated
     * if the guard evaluates to true.
     */
    public ASTExpression getTrueAlternative() {
        return (ASTExpression) jjtGetChild(1);
    }


    /**
     * Returns the node that represents the expression that will be evaluated
     * if the guard evaluates to false.
     */
    public Node getFalseAlternative() {
        return jjtGetChild(2);
    }


    @Override
    public Object jjtAccept(JavaParserVisitor visitor, Object data) {
        return visitor.visit(this, data);
    }
}
